<template>
  <div class="show">
    <router-link to="/recipes">Index</router-link>
    <router-link v-bind:to="'/recipes/update/'+recipe.uuid">Update</router-link>

    <div class="row">
        <div class="col-md-12">
        <h3 class="text-center">{{recipe.title}}</h3>
        </div>
    </div>

    <div class="row">
        <div class="col-md-8 offset-md-1">
            <div class="table-responsive">
            <table class="table table-sm table-bordered">
                <tr>
                    <td>UUID:</td>
                    <td>{{recipe.uuid}}</td>
                </tr>
                <tr>
                    <td>Post Date</td>
                    <td>{{recipe.postDate}}</td>
                </tr>
                <tr>
                    <td>Edit Date</td>
                    <td>{{recipe.editDate}}</td>
                </tr>
            </table>
            </div>
          <div>
            <h3>Description</h3>
            <p>{{recipe.description}}</p>
          </div>
          <div>
            Serves: {{recipe.servings}} <br>
            Preparation Time: {{recipe.prepTime}}<br>
            Cook Time: {{recipe.cookTime}}<br>
          </div>
          <div>
            Ingredients:
            <ul>
              <li v-for="x in recipe.ingredients" :key="x.uuid">
                {{x.name}}<div v-if="ingredientMatches(x.uuid).length > 0">
                    <b>Special/s</b>:<div v-for="x in ingredientMatches(x.uuid)" :key="x.uuid">{{x.title}}, {{x.type}}
                      {{x.text}}
                    </div>
                </div>
              </li>
            </ul>
          </div>
          <div>
            Directions:
             <ol>
              <li v-for="x in recipe.directions" :key="x.uuid">
                {{x.instructions}} <span v-if="x.optional == true">( Optional! )</span>
              </li>
            </ol>
          </div>
        </div>

        <div class="col-md-3">
            <span v-if="recipe.images">
              <img :src="'http://localhost:3001' + recipe.images.small">
            </span>
            <span v-else>No image available</span>
        </div>
    </div>

  </div>
</template>

<script>
export default {
  name: 'show',
  data () {
    return {
      recipe: '',
      specials: []
    }
  },
  methods: {
    fetchRecipe (uuid) {
      this.$http
        .get('http://localhost:3001/recipes/' + uuid)
        .then(function (response) {
          this.recipe = response.body
        })
    },
    fetchSpecials () {
      this.$http
        .get('http://localhost:3001/specials')
        .then(function (response) {
          this.specials = response.body
        })
    },
    ingredientMatches (id) {
      const search = (text) => this.specials.filter(x => x.ingredientId.includes(text))
      const result = search(id)
      return result
    }
  },
  created: function () {
    this.$forceUpdate()
    this.fetchRecipe(this.$route.params.id)
    this.fetchSpecials()
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped>
</style>
